unit DataCallTest1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, CiaDataCall;

const
   WM_DIALNEXT = WM_USER + 1;

type
  TForm1 = class(TForm)
    DataCall: TCiaDataCall;
    Memo1: TMemo;
    Panel1: TPanel;
    CallBtn: TButton;
    procedure CallBtnClick(Sender: TObject);
    procedure DataCallChangeState(Sender: TObject;
      NewState: TCiaDataCallState);
    procedure DataCallClosed(Sender: TObject);
    procedure DataCallConnect(Sender: TObject);
    procedure DataCallDataAvailable(Sender: TObject; const Data: String);
    procedure DataCallSend(Sender: TObject; const Data: String);
    procedure DataCallTimeOut(Sender: TObject; OldState: TCiaDataCallState;
      var AutoHandle: Boolean);
  private
    procedure Log(const Data: string);
    procedure WMDialNext(var Msg: TMessage); message WM_DIALNEXT;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WMDialNext(var Msg: TMessage);
begin
   // This is the place to call next number if any
end;

procedure TForm1.Log(const Data: string);
begin
   Memo1.Lines.Add(Data);
end;

procedure TForm1.CallBtnClick(Sender: TObject);
begin
   DataCall.Connect('323123456');
end;

procedure TForm1.DataCallChangeState(Sender: TObject;
  NewState: TCiaDataCallState);
begin
   Log('State: ' + aDataCallState[NewState]);
end;

procedure TForm1.DataCallClosed(Sender: TObject);
begin
   Log('Connection closed');
   PostMessage(Handle, WM_DIALNEXT, 0, 0);
end;

procedure TForm1.DataCallConnect(Sender: TObject);
begin
   Log('Connection etablished');
end;

procedure TForm1.DataCallDataAvailable(Sender: TObject;
  const Data: String);
begin
   Log('Received: ' + Data);
   // This is the place to handle incoming data or send data
   with Sender as TCiaDatacall do
      SendStr('OK'#13#10);
end;

procedure TForm1.DataCallSend(Sender: TObject; const Data: String);
begin
   Log('Send to port: ' + Data);
end;

procedure TForm1.DataCallTimeOut(Sender: TObject;
  OldState: TCiaDataCallState; var AutoHandle: Boolean);
begin
   Log('Timed out in state: ' + aDataCallState[OldState]);
   AutoHandle := True;  // let the component handle the errors
end;

end.
